<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Document</title>
  <style>
    :root {
      --gray: rgb(126, 126, 126);
      --yellow: rgb(247, 189, 119);
      --balck: rgb(0, 0, 0);
      --white-gray: rgb(204, 204, 204);
      --sky: #68b5d3;
      --dark-green: rgb(34, 65, 4);
      --green: rgb(121, 233, 10);
      --white: rgb(255, 255, 255);
    }

    body {
      background-image: url('./images/station.jpg');
      background-repeat: no-repeat;
      background-size: cover;
      display: flex;
      flex-direction: column;
      justify-content: space-around;
      align-items: center;
      height: 100vh;
      overflow: hidden;
      font-family: Arial, Helvetica, sans-serif;
    }

    .made {
      color: var(--white);
      position: absolute;
      right: 130px;
      bottom: -340px;
    }

    .text-wrapper {
      width: 90%;
      height: 250px;
      background-color: var(--gray);
      border-radius: 5px;
      display: flex;
      justify-content: center;
    }

    .text-panel {
      background-color: var(--yellow);
      width: 50%;
      height: 250px;
      border-radius: 5px;
      word-wrap: break-word;
      padding: 0 10px;
    }

    .levers__list {
      width: 65%;
      display: flex;
      justify-content: space-around;
    }

    .lever__wrapper {
      position: relative;
      background-color: var(--balck);
      width: 50px;
      height: 300px;
    }

    .lever__item {
      position: absolute;
      right: 15px;
      top: -5px;
      list-style: none;
      background-color: var(--white-gray);
      height: 170px;
      width: 20px;
    }

    .lever__item::after {
      position: absolute;
      right: -20px;
      top: -5px;
      content: '';
      display: inline-block;
      width: 60px;
      height: 60px;
      border-radius: 50%;
      background-color: var(--sky);
    }

    .lever__item-reversed {
      transform: rotateX(180deg);
      top: 170px;
    }

    .lights {
      width: 50px;
      height: 50px;
      background-color: var(--dark-green);
      border-radius: 50%;
      position: absolute;
      bottom: -100px;
    }

    .lights-active {
      background-color: var(--green);
    }
  </style>
</head>

<body>
  <div class="levers__list">
    <div class="lever__wrapper">
      <div class="lever__item lever__item-reversed"></div>
      <div class="lights"></div>
      <h1 class="made">Made in China by Indus</h1>
    </div>
    <div class="lever__wrapper">
      <div class="lever__item lever__item-reversed"></div>
      <div class="lights"></div>
    </div>
    <div class="lever__wrapper">
      <div class="lever__item lever__item-reversed"></div>
      <div class="lights"></div>
    </div>
    <div class="lever__wrapper">
      <div class="lever__item lever__item-reversed"></div>
      <div class="lights"></div>
    </div>
  </div>
  <div class="text-wrapper">
    <div class="text-panel">

    </div>
  </div>
  <script>
    const levers = document.querySelectorAll('.lever__item');
    const lights = document.querySelectorAll('.lights');
    const textPanel = document.querySelector('.text-panel');

    function changeLeverPosition(check) {
      Object.values(check).forEach((el, index) => {
        if (el === false) {
          levers[index].classList.add('lever__item-reversed');
          lights[index].classList.remove('lights-active');
        } else {
          levers[index].classList.remove('lever__item-reversed');
          lights[index].classList.add('lights-active');
        }
      });
    }

    function printInformation(text) {
      const p = document.createElement('p');
      p.innerText = text;
      textPanel.appendChild(p);
    }

    const socket = new WebSocket('ws://vps.yojji.io', 'denys_fedorenko');

    const requestForCheck = {
      action: 'check',
      'lever1': 0,
      'lever2': 1,
      stateId: 'some-state-id',
    }

    const powerOff = {
      action: 'powerOff',
      stateId: 'some-state-id',
    }

    const check = {
      0: true,
      1: true,
      2: true,
      3: true,
    };

    let stateToFinish = false;

    socket.onopen = function () {
      printInformation('Connection is set')
    };

    socket.onmessage = function (e) {
      const message = JSON.parse(e.data);

      if (message.newState === 'poweredOff') {
        printInformation(`Congratulations! We have stopped this hellish mechanism! Your token: ${message.token}`)
        socket.close();

        return
      }

      if (message.newState === 'poweredOn') {
        stateToFinish = !stateToFinish;
        printInformation('The first try failed! The next one will be success');
      }

      if (message.pulled >= 0) {
        check[message.pulled] = !check[message.pulled];

        changeLeverPosition(check);

        requestForCheck['lever2'] = message.pulled;
        requestForCheck.stateId = message.stateId;

        if (requestForCheck['lever1'] === requestForCheck['lever2']) {
          return
        }

        socket.send(JSON.stringify(requestForCheck));
      }

      if (message.action === 'check') {
        if (message.same) {
          check[requestForCheck['lever2']] = check[0];
          const allLeversAreSame = Object.values(check).every(el => el === stateToFinish);

          if (allLeversAreSame) {
            powerOff.stateId = message.stateId;
            socket.send(JSON.stringify(powerOff));
          }

          return
        }
        check[requestForCheck['lever2']] = !check[0];
      }

      return
    };

  </script>
</body>

</html>